function A = numbering_matrix_one_oddodd(m,n)
% This function will give back the optimal tour for n and m both odd with radius 1
% given in a matrix A.

% First the odd vertices will be filled:

A = zeros(m,n);

B = A;
i = m;

count = 1;

% Special case m = n = 3

if m == 3 && m == n
    A = [6,1,8;2,7,4;5,3,9];
    return
end

while i >= 3, 
    
    m1 = size(A,1);
    n1 = size(A,2);
    
    if mod(m,4) == 3 && m1 == 3 
        
        A(1,2) = count;
        count = count+1;
        A(2,1) = count;
        count = count+1;
        A(3,2) = count;
        count = count+1;
        
        A(2,3:2:n1) = count:2:count+2*length(3:2:n1)-2;
        A(3,4:2:n1-1) = count+1:2:count+2*length(4:2:n1-1)-1;
        count = count+2*length(3:2:n1)-2+1;
        
        A(1,n1-1:-2:4) = count:count+length(n1-1:-2:4)-1;
        count = count+length(n1-1:-2:4);
        
    elseif mod(m,4) == 1 && m1 == 5
        A(1:2:m1,2) = count:2:count+2*length(1:2:m1)-2;
        A(2:2:m1-1,1) = count+1:2:count+2*length(2:2:m1-1)-1;
        count = count+2*length(1:2:m1)-2+1;

        A(m1-1,3:2:n1) = count:2:count+2*length(3:2:n1)-2;
        A(m1,4:2:n1-1) = count+1:2:count+2*length(4:2:n1-1)-1;
        count = count+2*length(3:2:n1)-2+1;

        A(m1-2:-2:1,n1-1) = count:2:count+2*length(m1-2:-2:1)-2;
        A(m1-3:-2:2,n1) = count+1:2:count+2*length(m1-3:-2:2)-1;
        count = count+2*length(m1-2:-2:1)-2+1;

        A(2,n1-2:-2:3) = count:2:count+2*length(n1-2:-2:3)-2;
        A(1,n1-3:-2:4) = count+1:2:count+2*length(n1-3:-2:4)-1;
        count = count+2*length(n1-2:-2:3)-2+1;
        
        if m ~= n % Fills up the empty row
        A(3,4:2:n1-3) = count:count+length(4:2:n1-3)-1;
        count = count+length(4:2:n1-3)-1+1;
        end
        
    else
        A(1:2:m1,2) = count:2:count+2*length(1:2:m1)-2;
        A(2:2:m1-1,1) = count+1:2:count+2*length(2:2:m1-1)-1;
        count = count+2*length(1:2:m1)-2+1;

        A(m1-1,3:2:n1) = count:2:count+2*length(3:2:n1)-2;
        A(m1,4:2:n1-1) = count+1:2:count+2*length(4:2:n1-1)-1;
        count = count+2*length(3:2:n1)-2+1;

        A(m1-2:-2:1,n1-1) = count:2:count+2*length(m1-2:-2:1)-2;
        A(m1-3:-2:2,n1) = count+1:2:count+2*length(m1-3:-2:2)-1;
        count = count+2*length(m1-2:-2:1)-2+1;

        A(2,n1-2:-2:3) = count:2:count+2*length(n1-2:-2:3)-2;
        A(1,n1-3:-2:4) = count+1:2:count+2*length(n1-3:-2:4)-1;
        count = count+2*length(n1-2:-2:3)-2+1;
    
    end
    i = i-4;

    m2 = size(B,1);
    n2 = size(B,2);

    a = (m2-m1)/2+1;
    b = (n2-n1)/2+1;

    B(a:m2-a+1,b:n2-b+1) = A;
    A = A(3:m1-2,3:n1-2);
    

end

A = B;

% Now the even vertices will be filled:

if m == 3
    count = m*n;
    %count = countHelp-count;
    A(3,1) = count;
    count = count-1;
    A(1,1) = count;
    count = count-1;
    
    A(2,2:2:n-1) = count:-2:count-2*length(2:2:n-1)+2;
    A(1,3:2:n) = count-1:-2:count-2*length(3:2:n)+1;
    count = count-2*length(3:2:n)+1-1;
    
    A(3,n:-2:3) = count:-1:count-length(n:-2:3)+1;
    %count = count+length(n:-2:3)-1;
    
elseif m == 5 && m == n
    B = [15,0,14,0,13;0,16,0,18,0;25,0,17,0,19;0,24,0,21,0;23,0,22,0,20];
    A = A + B;  
    
elseif m == 5 && n > m % started in (3,1) but inverted numbering
    count = m*n;
    A(3,1) = count;
    count = count-1;
    
    A(5,1:2:n-4) = count:-2:count-2*length(1:2:n-4)+2;
    A(4,2:2:n-3) = count-1:-2:count-2*length(2:2:n-3)+1;
    count = count-2*length(2:2:n-3)+1-1;
    
    A(3,n-4:-2:3) = count:-1:count-length(n-4:-2:3)+1;
    count = count-length(n-4:-2:3)+1-1;
    
    A(2,2) = count;
    count = count-1;
    A(1,1) = count;
    count = count-1;
    
    A(1,3:2:n) = count:-2:count-2*length(3:2:n)+2;
    A(2,4:2:n-1) = count-1:-2:count-2*length(4:2:n-1)+1;
    count = count-2*length(3:2:n)+2-1;

    A(3,n:-2:n-2) = count:-1:count-length(n:-2:n-2)+1;
    count = count-length(n:-2:n-2)+1-1;
    
    A(4,n-1) = count;
    count = count-1;
    A(5,n) = count;
    count = count-1;
    A(5,n-2) = count;
    count = count-1;

elseif (m >= 7 && mod(m,4) == 3) || (m >= 9 && mod(m,4) == 1)
        i = m;
        B = zeros(size(A));
        C = zeros(size(A));
               
        while i >= 7
            m1 = size(B,1);
            n1 = size(B,2);
            if i > 9 
                B(3,1) = count;
                count = count+1;
                B(1,1:2:n1) = count:2:count+2*length(1:2:n1)-2;
                B(2,2:2:n1-1) = count+1:2:count+2*length(2:2:n1-1)-1;
                count = count+2*length(1:2:n1)-2+1;
                
                B(3:2:m1,n1) = count:2:count+2*length(3:2:m1)-2;
                B(4:2:m1-1,n1-1) = count+1:2:count+2*length(4:2:m1-1)-1;
                count = count+2*length(3:2:m1)-2+1;
                
                B(m1,n1-2:-2:1) = count:2:count+2*length(n1-2:-2:1)-2;
                B(m1-1,n1-3:-2:2) = count+1:2:count+2*length(n1-3:-2:2)-1;
                count = count+2*length(n1-2:-2:1)-2+1;
                
                B(m1-2:-2:5,1) = count:2:count+2*length(m1-2:-2:5)-2;
                B(m1-3:-2:4,2) = count+1:2:count+2*length(m1-3:-2:4)-1;
                count = count+2*length(m1-3:-2:4)-1+1;  
                
            else
                B(3:2:m1,1) = count:2:count+2*length(3:2:m1)-2;
                B(4:2:m1-1,2) = count+1:2:count+2*length(4:2:m1-1)-1;
                count = count+2*length(3:2:m1)-2+1;
                
                B(m1,3:2:n1) = count:2:count+2*length(3:2:n1)-2;
                B(m1-1,4:2:n1-1) = count+1:2:count+2*length(4:2:n1-1)-1;
                count = count+2*length(3:2:n1)-2+1;
                
                B(m1-2:-2:1,n1) = count:2:count+2*length(m1-2:-2:1)-2;
                B(m1-3:-2:2,n1-1) = count+1:2:count+2*length(m1-3:-2:2)-1;
                count = count+2*length(m1-2:-2:1)-2+1;
                
                B(1,n1-2:-2:3) = count:2:count+2*length(n1-2:-2:3)-2;
                B(2,n1-3:-2:4) = count+1:2:count+2*length(n1-3:-2:4)-1;
                count = count+2*length(n1-2:-2:3)-2+1;
                
                for i = 1:4,
                    B(i,i) = count;
                    count = count+1;
                end
                
                if m >= 7 && mod(m,4) == 3
                    if m < n
                        B(5,3) = count;
                        count = count+1;
                        B(5,5) = count;
                        count = count+1;

                        B(4,6) = count;
                        count = count+1;
                        B(3,5) = count;
                        count = count+1;

                        B(4,8:2:n1-3) = count+1:2:count+2*length(8:2:n1-3)-1;
                        B(3,7:2:n1-2) = count:2:count+2*length(7:2:n1-2)-2;
                        count = count+2*length(7:2:n1-2)-2+1;

                        B(5,n1-2:-2:7) = count:count+length(6:2:n1-3)-1;
                        
                    elseif m == n
                        B(3,5) = count;
                        count = count+1;
                        B(5,5) = count;
                        count = count+1;
                        B(5,3) = count;
                        
                    end
                elseif m >= 9 && mod(m,4) == 1
                    if m < n
                        B(5:2:7,3) = count:2:count+4-2;
                        B(6,4) = count+1;
                        count = count+4-2+1;
                        
                        B(7,5:2:n1-6) = count:2:count+2*length(5:2:n1-6)-2;
                        B(6,6:2:n1-5) = count+1:2:count+2*length(6:2:n1-5)-1;
                        count = count+2*length(6:2:n1-5)-1+1;
                        
                        B(5,n1-6:-2:5) = count:count+length(n1-6:-2:5)-1;
                        count = count+length(n1-6:-2:5)-1+1;
                        B(4,6) = count;
                        count = count+1;
                        B(3,5) = count;
                        count = count+1;
                        
                        B(3,7:2:n1-2) = count:2:count+2*length(7:2:n1-2)-2;
                        B(4,8:2:n1-3) = count+1:2:count+2*length(8:2:n1-3)-1;
                        count = count+2*length(7:2:n1-2)-2+1;
                        
                        B(5,n1-2) = count;
                        count = count+1;
                        B(5,n1-4) = count;
                        count = count+1;
                        B(6,n1-3) = count;
                        count = count+1;
                        B(7,n1-2) = count;
                        count = count+1;
                        B(7,n1-4) = count;
                        count = count+1;
                        
                    elseif m == n
                        B(3,5:2:7) = count:2:count+4-2;
                        B(4,6) = count+1;
                        count = count+4-2+1;
                        
                        B(5,7:-2:5) = count:count+2-1;
                        count = count+2-1+1;
                        B(6,6) = count;
                        B(7,7) = count+1;
                        B(7,5) = count+2;
                        B(6,4) = count+3;
                        B(7,3) = count+4;
                        B(5,3) = count+5;
                        count = count+5;
                        
                    end
                end
            end
            i = i-4;

            a = (m-m1)/2+1;
            b = (n-n1)/2+1;

            C(a:m-a+1,b:n-b+1) = B;
            B = B(3:m1-2,3:n1-2);
        end
        ma = max(C(:));
        mi = C(3,1);
        help = ma+1;
        h = mi;
        for i = ma:-1:mi,
            [r,c] = find(C == i);
            C(r,c) = help;
            help = help+1;
        end
        for i = ma+1:help-1,
            [r,c] = find(C == i);
            C(r,c) = h;
            h = h+1;
        end
        A = A+C;    
end

