function A = numbering_matrix_sr2(m,n)

% This function will give back the optimal tour for any n and m and
% radius sqrt(2) given in a matrix A.

% First the case m = 3 and n >= 4

A = zeros(m,n);
count = 1;
if m == 1
    A = numbering_matrix_one_specialcases(m,n);
elseif m == 3 && n >= 4 && n <= 6
    if n == 4
        A = [3 5 11 9; 1 8 2 7; 4 6 12 10];
    elseif n == 5
        A = [5 7 4 11 13; 1 10 2 9 3; 6 8 15 12 14];
    elseif n == 6
        A = [5 7 4 13 16 14; 1 12 2 11 3 10; 6 8 18 9 17 15];
    end
                
elseif m == 3 && n >= 7
    if mod(n,2) == 1
        %Visit all (e,o)-vertices
        A(2,1:2:n) = count:count+length(1:2:n)-1;
        count = count+length(1:2:n)-1+1;
        %Go to (1,n-2) and visit all (o,o)-vertices counter-clockwise
        A(1,n-2:-2:1) = count:count+length(n-2:-2:1)-1;
        count = count+length(n-2:-2:1)-1+1;
        A(3,1)= count;
        count = count+1;
        A(1,2) = count;
        count = count+1;
        %Go from (3,2) to (3,n-3) and visit all (o,e)-vertices counter clockwise
        A(3,2:2:n-3) = count:count+length(2:2:n-3)-1;
        count = count+length(2:2:n-3)-1+1;
        A(2,n-1) = count;
        count = count+1;
        %Visit all (e,e)-vertices
        A(2,n-3:-2:2) = count:count+length(n-3:-2:2)-1;
        count = count+length(n-3:-2:2)-1+1;
        %Visit the remainig (o,e)-vertices reaching (3,n-1)
        A(1,4:2:n-3) = count:count+length(4:2:n-3)-1;
        count = count+length(4:2:n-3)-1+1;
        A(1:2:3,n-1) = count:count+length(1:2:3)-1;
        count = count+length(1:2:3)-1+1;
        A(1,n) = count;
        count = count+1;
        %Visit the remaining (o,o)-vertices counter-clockwise
        A(3,n:-2:3) = count:count+length(n:-2:3)-1;
        count = count+length(n:-2:3)-1+1;
    else
        %Visit all (e,o)-vertices
        A(2,1:2:n-1) = count:count+length(1:2:n-1)-1;
        count = count+length(1:2:n-1)-1+1;
        %Go to (1,n-2) and visit all (o,o)-vertices counter-clockwise
        A(1,n-3:-2:1) = count:count+length(n-3:-2:1)-1;
        count = count+length(n-3:-2:1)-1+1;
        A(3,1)= count;
        count = count+1;
        A(1,2) = count;
        count = count+1;
        %Go from (3,2) to (3,n-3) and visit all (o,e)-vertices counter clockwise
        A(3,2:2:n-2) = count:count+length(2:2:n-2)-1;
        count = count+length(2:2:n-2)-1+1;
        %Visit all (e,e)-vertices
        A(2,n:-2:2) = count:count+length(n:-2:2)-1;
        count = count+length(n:-2:2)-1+1;
        %Visit the remainig (o,e)-vertices reaching (3,n-1)
        A(1,4:2:n-2) = count:count+length(4:2:n-2)-1;
        count = count+length(4:2:n-2)-1+1;
        A(1:2:3,n) = count:count+length(1:2:3)-1;
        count = count+length(1:2:3)-1+1;
        A(1,n-1) = count;
        count = count+1;
        %Visit the remaining (o,o)-vertices counter-clockwise
        A(3,n-1:-2:3) = count:count+length(n-1:-2:3)-1;
        count = count+length(n-1:-2:3)-1+1;
    end
    
elseif m >= 4
    type = 0;
    mVec = [1:m];
    nVec = [1:n];
    re = length(mVec(2:2:m));
    ro = length(mVec(1:2:m));
    ce = length(nVec(2:2:n));
    co = length(nVec(1:2:n));
    
    if mod(ro,2) == 0 && mod(re,2) == 0
        if (mod(co,2) == 0 && mod(ce,2) == 0) || (mod(co,2) == 0 && mod(ce,2) == 1) || (mod(co,2) == 1 && mod(ce,2) == 0) ||  (mod(co,2) == 1 && mod(ce,2) == 1)
            type = 1;
        end
    elseif mod(co,2) == 0 && mod(ce,2) == 0
        if (mod(ro,2) == 0 && mod(re,2) == 1) || (mod(ro,2) == 1 && mod(re,2) == 0) || (mod(ro,2) == 1 && mod(re,2) == 1)
            type = 1;
        end
    elseif mod(ro,2) == 0 && mod(re,2) == 1
        if mod(co,2) == 0 && mod(ce,2) == 1
            type = 2;
        elseif mod(co,2) == 1 && mod(ce,2) == 0
            type = 3;
        elseif mod(co,2) == 1 && mod(ce,2) == 1
            type = 4;
        end
    elseif mod(ro,2) == 1 && mod(re,2) == 0
        if mod(co,2) == 0 && mod(ce,2) == 1
            type = 5;
        elseif mod(co,2) == 1 && mod(ce,2) == 0
            type = 6;
        elseif mod(co,2) == 1 && mod(ce,2) == 1
            type = 7;
        end
    elseif mod(ro,2) == 1 && mod(re,2) == 1
        if mod(co,2) == 0 && mod(ce,2) == 1
            type = 8;
        elseif mod(co,2) == 1 && mod(ce,2) == 0
            type = 9;
        elseif mod(co,2) == 1 && mod(ce,2) == 1
            type = 10;
        end
    end
    
    A = numbering_matrix_sr2_types(type,m,n);
end